package infostuff;


import java.util.HashMap;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.scene.control.Alert;
import javafx.scene.control.Button;
import javafx.scene.control.DialogPane;
import javafx.scene.control.ListView;
import javafx.scene.control.TextArea;
import javafx.scene.layout.Background;
import javafx.scene.layout.BackgroundFill;
import javafx.scene.layout.HBox;
import javafx.scene.paint.Color;
import javafx.stage.Modality;

public class CmdHelpDialog extends Alert {

	Button close;
	ListView<String> cmdList;
	HBox hb;
	
	HashMap<Integer, String> cmdHelpText;
	
	public CmdHelpDialog() {
		super(AlertType.INFORMATION);
		setGraphic(null);
		setTitle("Commands Help");
		setHeaderText("Click on a command to see infomation on it.");
		initModality(Modality.NONE);
		
		DialogPane dp = this.getDialogPane();
		dp.setBackground(new Background(new BackgroundFill(Color.DARKGRAY, null, null)));
		hb = new HBox();
		hb.setPrefSize(600, 400);
		dp.setPrefSize(600, 400);
		dp.setContent(hb);
		
		close = new Button("Close");
		setActions();
		
	}

	private void setActions() {
		close.setOnAction(e->{
			close();
		});
		
		cmdHelpText = new HashMap<>();
		addHelpText();
		
		ObservableList<String> cmds = FXCollections.observableArrayList( "@JUMP####",
		          "LineMark", "DisplayText", "FlushBuffers", "SetTextBox", "SetCursorPosition", "ExecuteScript", "MouseOverEvent", 
				"EnableSaveMenu", "GoTo", "JumpTo", "Return", "ConditionalJump", "LoadANI", "TweenFrames", "WaitForFrame", 
				"FadeFromBlack", "FadeToBlack", "SetRenderSize", "DrawImage", "LoadCG", "SetFontSize", "SetWindowSize", "SetRenderDimensions", 
				"LoadSaveFile", "TransformImageTo", "EnableImagePanRange", "WaitForTransform", "LoadBGM");
		
		cmdList = new ListView<>(cmds);
		TextArea ta = new TextArea();
		
		// add this when all written help is finished.
		//ta.setEditable(false);
		
		cmdList.setOnMouseClicked(e->{
			ta.setText(getHelpText(cmdList.getSelectionModel().getSelectedIndex()));
		});
		
		
		hb.getChildren().addAll(cmdList, ta);
		
		
	}

	private void addHelpText() {
		cmdHelpText.put(0, "@JUMP#### is a label target used in \nthe jump commands (GoTo, JumpTo and ConditionalJump)\n example \"@JUMP0001\" \n\nThe text parser will calculate the new offset and \nautomatically repalce the text with the correct offset.");
		cmdHelpText.put(1, "LineMark seems to be a debug feature\nperhaps left in to debug the scripts\nIt stores a number in memory but it doesn't\ndo too much else. Can be removed without any effect.");
		cmdHelpText.put(2, "DisplayText is where all the dialogue, choice texts are stored\nOnly 3 should be used at a time, after you use 3, \nuse the FlushBuffers command to make them appear on screen.\nIf you use more than 3 the AGS engine will pop up a warning message.");
		cmdHelpText.put(3, "FlushBuffers will take the commmands issued and output them to screen\nThis includes text and image data");
		
		cmdHelpText.put(5, "SetCursorPosition");
		cmdHelpText.put(8, "This simply enables and disables the Save menu.\n0 = disabled\n1 = enabled");
		
		cmdHelpText.put(9, "GoTo is a hard jump, unlike JumpTo it won't return when the game\ncomes across a \"Return\" statement.");
		cmdHelpText.put(10,"JumpTo will jump to a new position in the script\nuntil you hit a \"Return\" statement, then it will return to the following\ncode after the original JumpTo command.");
		
		
		
	}
	
	private String getHelpText(int i) {
		String str;
		if (cmdHelpText.containsKey(i)) {
			str = cmdHelpText.get(i);
		} else {
			str = i + " is not defined";
		}
		
		
		return str;
	}

}
