package scriptparser;

import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;

public class DialogExtractor {
	
	BufferedOutputStream bos;
	BufferedWriter bw;
	
	String text;
	
	public DialogExtractor (File saveFile, String text) {
		
		this.text = text;
		
		try {
			bos = new BufferedOutputStream(new FileOutputStream(saveFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	
	public void processText() {
		String[] txtArr = text.split("\n");
		int lineNum = 1;
		String jpLineID = "_j";
		String engLineID = "_e";
		
		String jpTemp;
		String engTemp;
		
		ArrayList<String> arrList = new ArrayList<>();
		
		for (String s : txtArr) {
			if (!s.contains("DisplayText")) {
				continue;
			} else {
				jpTemp = get4Digits(lineNum) + jpLineID + ": " + s.substring(s.indexOf("(")+2, s.lastIndexOf(")")-1);
				engTemp = get4Digits(lineNum) + engLineID + ": ";
				lineNum++;
				arrList.add(jpTemp);
				arrList.add(engTemp);
			}
		}
		
		String toWrite = String.join(System.lineSeparator(), arrList);
		
		try {
			bos.write(toWrite.getBytes());
			bos.flush();
			bos.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

	private String get4Digits(int lineNum) {
		String temp = String.valueOf(lineNum);
		while(temp.length() < 4) {
			temp = "0" + temp;
		}
		return temp;
	}

}
