package scriptparser;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

public class DialogImporter {
	
	BufferedInputStream bos;
	BufferedReader bw;
	
	String text;
	HashMap<String, String> translator;
	
	public DialogImporter(File inputFile, String text) {
		this.text = text;
		
		try {
			bos = new BufferedInputStream(new FileInputStream(inputFile));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
	}
	
	public void processText() {
		ArrayList<String> arrList = new ArrayList<>();
		translator = new HashMap<>();
		
		byte[] openedData;
		
		try {
			openedData = new byte[bos.available()];
			bos.read(openedData);
			
			for (String s: new String(openedData).split("\n")) {
				arrList.add(s);
			}
			
			
			for (int i = 0; i < arrList.size(); i += 2) {
				String j = arrList.get(i);
				String e = arrList.get(i+1);
				if (j.contains("(\"") && j.contains("\")")) {
					j = j.substring(j.indexOf("(")+2, j.lastIndexOf(")")-1);
				} else {
					j = j.substring(j.indexOf(":")+2, j.length()-1);
				}
				
				
				
				if (e.contains(")") && e.contains("(")) {
					e = e.substring(e.indexOf("("), e.lastIndexOf(")"));
				} else {
					e = e.substring(e.indexOf(":")+2, e.length());
				}
				
				
				translator.put(j, e);
				
			}
			
			//for (String s: translator.keySet()) {
				//System.out.print("[" + s); 
				//System.out.println("]-> [" + translator.get(s) + "]");
			//}
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

	public String replaceText() {
		
		
		for (String s : text.split("\n")) {
			if (!s.contains("DisplayText")) {
				continue;
			} else {
				String temp = s.substring(s.indexOf("(\"")+2, s.lastIndexOf("\")") );
				
				if (translator.get(temp) != null && !translator.get(temp).trim().isEmpty()  ) {
					text = text.replace(temp, translator.get(temp));
				}
				
			}
		}
		
		
		return text;
	}

}
