package scriptparser;

import java.util.ArrayList;

import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;

public class ErrorTracker {
	
	static  enum ErrorType{
		PARSING,
		WRITING
	}
	
	static ErrorType eType;
	static ArrayList<String> errorList;
	
	static public void addError(ErrorType e, String line) {
		if (errorList == null) {
			errorList = new ArrayList<>();
		}
		eType  = e;
		errorList.add(line);
		
		
	}
	
	static public void prepErrorTracking() {
		errorList = null;
	}
	
	static public void showErrorDialog() {
		
		String errorMsg = "ErrorType: " + eType.toString() + "\n";
		errorList.add(0, errorMsg);
		if (errorList.size() > 12) {
			for (int i = 1; i < 12; i++) {
				errorMsg += errorList.get(i);
			}
			errorMsg += "....list too long, truncated.";
			
		} else {
			errorMsg = String.join("", errorList);
		}
	
		
		Alert alert = new Alert(AlertType.ERROR, errorMsg);
		alert.setHeaderText("Error(s) occured: " + (errorList.size()-1));
		alert.show();
	}
	
	static public boolean checkErrors() {
		return errorList != null;
	}
}
